From 0cfa26bc59668717d954f5673438337597f671ee Mon Sep 17 00:00:00 2001
From: Clement Verna <cverna@tutanota.com>
Date: Apr 22 2016 08:45:09 +0000
Subject: [PATCH 15/24] FAS and TRAC support added to importer


---

diff --git a/pagure_importer/lib/fas.py b/pagure_importer/lib/fas.py
new file mode 100644
index 0000000..b63f665
--- /dev/null
+++ b/pagure_importer/lib/fas.py
@@ -0,0 +1,23 @@
+from fedora.client.fas2 import AccountSystem
+from pagure_importer.lib.models import User
+
+
+class FASclient ():
+    def __init__(self, fas_username, fas_password, fas_url):
+        self.fasclient = AccountSystem(fas_url, username=fas_username,
+                                       password=fas_password)
+
+        anonymous = User(name='', fullname='', emails=[])
+        self.fasuser = {'': anonymous}
+
+    def find_fas_user(self, user):
+
+        if user not in self.fasuser.keys():
+            person = self.fasclient.person_by_username(user)
+            if not person:
+                return self.fasuser['']
+
+            self.fasuser[user] = User(name=user,
+                                      fullname=person['human_name'],
+                                      emails=[person['email']])
+        return self.fasuser[user]
diff --git a/pagure_importer/lib/sources/importer_trac.py b/pagure_importer/lib/sources/importer_trac.py
index 2e6fce2..f69a3ce 100644
--- a/pagure_importer/lib/sources/importer_trac.py
+++ b/pagure_importer/lib/sources/importer_trac.py
@@ -1,21 +1,17 @@
 from xmlrpclib import ServerProxy
 import pagure_importer
 import pagure_importer.lib
-from pagure_importer.lib import models
-from fedora.client.fas2 import AccountSystem
-from datetime import datetime
+from pagure_importer.lib.fas import FASclient
+from pagure_importer.lib import trac
 
 
 class TracImporter():
     '''Pagure importer for trac instance'''
 
     def __init__(self, trac_project_url):
-        self.trac = ServerProxy(trac_project_url + '/rpc')
-        fas_url = 'https://admin.fedoraproject.org/accounts'
-        fas_username = 'user'
-        fas_password = 'pass'
-        self.fasclient = AccountSystem(fas_url, username=fas_username,
-                                       password=fas_password)
+        self.tracclient = ServerProxy(trac_project_url + '/rpc')
+        self.fasclient = FASclient('user', 'password',
+                                   'https://admin.fedoraproject.org/accounts')
 
     def _find_fas_user(self, user):
         person = self.fasclient.person_by_username(user)
@@ -115,14 +111,16 @@ class TracImporter():
     def import_issues(self, repo_path, repo_folder,
                       trac_query='max=0&order=id'):
         '''Import issues from trac instance using xmlrpc API'''
-        tickets_id = self.trac.ticket.query(trac_query)
+        tickets_id = self.tracclient.ticket.query(trac_query)
 
         for ticket_id in tickets_id:
 
-            pagure_issue = self._populate_issue(ticket_id)
+            pagure_issue = trac.populate_issue(self.tracclient,
+                                               self.fasclient, ticket_id)
 
-            pagure_issue_comments = self.trac.ticket.changeLog(ticket_id)
-            comments = self._populate_comments(pagure_issue_comments)
+            pagure_issue_comments = self.tracclient.ticket.changeLog(ticket_id)
+            comments = trac.populate_comments(self.fasclient,
+                                              pagure_issue_comments)
 
             # add all the comments to the issue object
             pagure_issue.comments = comments
diff --git a/pagure_importer/lib/trac.py b/pagure_importer/lib/trac.py
new file mode 100644
index 0000000..fb3d062
--- /dev/null
+++ b/pagure_importer/lib/trac.py
@@ -0,0 +1,90 @@
+from pagure_importer.lib.models import IssueComment, Issue
+from datetime import datetime
+
+
+def get_ticket_tags(trac_ticket):
+    return []
+
+
+def get_ticket_status(trac_ticket):
+    ''' Converts Trac ticket status
+        to Pagure issue status'''
+
+    if trac_ticket['status'] != 'closed':
+        ticket_status = 'Open'
+    else:
+        ticket_status = 'Fixed'
+    return ticket_status
+
+
+def populate_comments(fasclient, trac_comments):
+    comments = []
+    for comment in trac_comments:
+        if comment[2] == 'comment' and comment[4] != '':
+            comment_user = comment[1]
+            pagure_issue_comment_user_email = None
+            pagure_issue_comment_body = comment[4]
+            pagure_issue_comment_created_at = datetime.strptime(
+                comment[0].value, "%Y%m%dT%H:%M:%S")
+            pagure_issue_comment_updated_at = None
+
+            # No idea what to do with this right now
+            # editor: not supported by github api
+            pagure_issue_comment_parent = None
+            pagure_issue_comment_editor = None
+
+            # comment updated at
+            pagure_issue_comment_edited_on = None
+
+            # The User who commented
+            pagure_issue_comment_user = fasclient.find_fas_user(comment[1])
+
+            # Object to represent comment on an issue
+            pagure_issue_comment = IssueComment(
+                id=None,
+                comment=pagure_issue_comment_body,
+                parent=pagure_issue_comment_parent,
+                date_created=pagure_issue_comment_created_at,
+                user=pagure_issue_comment_user.to_json(),
+                edited_on=pagure_issue_comment_edited_on,
+                editor=pagure_issue_comment_editor)
+
+            comments.append(pagure_issue_comment.to_json())
+    return comments
+
+
+def populate_issue(trac, fasclient, ticket_id):
+    trac_ticket = trac.ticket.get(ticket_id)[3]
+    pagure_issue_title = trac_ticket['summary']
+    pagure_issue_content = trac_ticket['description']
+
+    if pagure_issue_content == '':
+        pagure_issue_content = '#No Description Provided'
+
+    pagure_issue_status = get_ticket_status(trac_ticket)
+
+    pagure_issue_created_at = datetime.strptime(
+        trac.ticket.get(ticket_id)[1].value, "%Y%m%dT%H:%M:%S")
+
+    pagure_issue_assignee = fasclient.find_fas_user(trac_ticket['owner'])
+
+    pagure_issue_tags = get_ticket_tags(trac_ticket)
+
+    pagure_issue_depends = []
+    pagure_issue_blocks = []
+    pagure_issue_is_private = False
+
+    pagure_issue_user = fasclient.find_fas_user(trac_ticket['reporter'])
+    pagure_issue = Issue(
+        id=ticket_id,
+        title=pagure_issue_title,
+        content=pagure_issue_content,
+        status=pagure_issue_status,
+        date_created=pagure_issue_created_at,
+        user=pagure_issue_user.to_json(),
+        private=pagure_issue_is_private,
+        tags=pagure_issue_tags,
+        depends=pagure_issue_depends,
+        blocks=pagure_issue_blocks,
+        assignee=pagure_issue_assignee.to_json())
+    return pagure_issue

